close all;
clear all;
%==========================================================================
% Cuk Converter
% Andrew Chuinard, Tim Chairet
% 4/30/09
%==========================================================================

%--------------------------------------------------------------------------
% Parameters
%--------------------------------------------------------------------------
syms Vg L1 L2 C1 C2 D Dprime R s
syms i1 i2 v1 v2
%--------------------------------------------------------------------------

%--------------------------------------------------------------------------
% Calculations
%--------------------------------------------------------------------------
xstate = [i1; i2; v1; v2];
% Matrices
A1 = [0 0 0 0; ...
      0 0 1/L2 1/L2; ...
      0 -1/C1 0 0; ...
      0 -1/C2 0 -1/(R*C2)];

A2 = [0 0 -1/L1 0; ...
      0 0 0 1/L2; ...
      1/C1 0 0 0; ...
      0 -1/C2 0 -1/(R*C2)];

B1 = [1/L1; 0; 0; 0];
B2 = [1/L1; 0; 0; 0];

C1 = [0 0 0 1];
C2 = [0 0 0 1];

E1 = 0;
E2 = 0;

A =  simplify(D*A1 + (1-D)*A2); 
B =  simplify(D*B1 + (1-D)*B2);
C =  simplify(D*C1 + (1-D)*C2);
E =  simplify(D*E1 + (1-D)*E2);

X = simplify(-A^-1*B*Vg);

Bd = simplify((A1-A2)*X + (B1-B2)*Vg);

sI = [s 0 0 0; ...
      0 s 0 0; ...
      0 0 s 0; ...
      0 0 0 s];
Den = simplify(det(sI-A));
Den = collect(Den, s);

V_D = simplify(C*(sI-A)^(-1)*Bd);
simpleV_D = collect(V_D, s)
pretty(V_D)
pretty(simpleV_D)

